StdArraySerializers.ArraySerializerBase (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map.ser.std

## Class StdArraySerializers.ArraySerializerBase<T>

- java.lang.Object
- - org.codehaus.jackson.map.JsonSerializer<T>
  - - org.codehaus.jackson.map.ser.std.SerializerBase<T>
    - - org.codehaus.jackson.map.ser.std.ContainerSerializerBase<T>
      - - org.codehaus.jackson.map.ser.std.StdArraySerializers.ArraySerializerBase<T>

- All Implemented Interfaces:
    SchemaAware
  Direct Known Subclasses:
    ObjectArraySerializer, StdArraySerializers.BooleanArraySerializer, StdArraySerializers.DoubleArraySerializer, StdArraySerializers.FloatArraySerializer, StdArraySerializers.IntArraySerializer, StdArraySerializers.LongArraySerializer, StdArraySerializers.ShortArraySerializer, StdArraySerializers.StringArraySerializer
  Enclosing class:
    StdArraySerializers

      public abstract static class StdArraySerializers.ArraySerializerBase<T>
      extends ContainerSerializerBase<T>

  Base class for serializers that will output contents as JSON arrays.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.JsonSerializer

      `JsonSerializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected BeanProperty` | `_property` Array-valued property being serialized with this instance
    `protected TypeSerializer` | `_valueTypeSerializer` Type serializer used for values, if any.

    - ### Fields inherited from class org.codehaus.jackson.map.ser.std.SerializerBase

      `_handledType`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `StdArraySerializers.ArraySerializerBase(Class<T> cls, TypeSerializer vts, BeanProperty property)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `serialize(T value, JsonGenerator jgen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
    `protected abstract void` | `serializeContents(T value, JsonGenerator jgen, SerializerProvider provider)`
    `void` | `serializeWithType(T value, JsonGenerator jgen, SerializerProvider provider, TypeSerializer typeSer)` Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

    - ### Methods inherited from class org.codehaus.jackson.map.ser.std.ContainerSerializerBase

      `_withValueTypeSerializer, withValueTypeSerializer`

    - ### Methods inherited from class org.codehaus.jackson.map.ser.std.SerializerBase

      `createObjectNode, createSchemaNode, createSchemaNode, getSchema, handledType, isDefaultSerializer, wrapAndThrow, wrapAndThrow, wrapAndThrow, wrapAndThrow`

    - ### Methods inherited from class org.codehaus.jackson.map.JsonSerializer

      `isUnwrappingSerializer, unwrappingSerializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _valueTypeSerializer

          protected final TypeSerializer _valueTypeSerializer

      Type serializer used for values, if any.

    - #### _property

          protected final BeanProperty _property

      Array-valued property being serialized with this instance
      Since:
        1.7

  - ### Constructor Detail

    - #### StdArraySerializers.ArraySerializerBase

          protected StdArraySerializers.ArraySerializerBase(Class<T> cls,
                                                 TypeSerializer vts,
                                                 BeanProperty property)

  - ### Method Detail

    - #### serialize

          public final void serialize(T value,
                       JsonGenerator jgen,
                       SerializerProvider provider)
                               throws IOException,
                                      JsonGenerationException

      Description copied from class: `JsonSerializer`
      Method that can be called to ask implementation to serialize values of type this serializer handles.
      Specified by:
        `serialize` in class `SerializerBase<T>`
      Parameters:
        `value` - Value to serialize; can not be null.
        `jgen` - Generator used to output resulting Json content
        `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### serializeWithType

          public final void serializeWithType(T value,
                               JsonGenerator jgen,
                               SerializerProvider provider,
                               TypeSerializer typeSer)
                                       throws IOException,
                                              JsonGenerationException

      Description copied from class: `JsonSerializer`
      Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

      Default implementation will ignore serialization of type information, and just calls `JsonSerializer.serialize(T, org.codehaus.jackson.JsonGenerator, org.codehaus.jackson.map.SerializerProvider)`: serializers that can embed type information should override this to implement actual handling. Most common such handling is done by something like:

            // note: method to call depends on whether this type is serialized as JSON scalar, object or Array!
            typeSer.writeTypePrefixForScalar(value, jgen);
            serialize(value, jgen, provider);
            typeSer.writeTypeSuffixForScalar(value, jgen);

      Overrides:
        `serializeWithType` in class `JsonSerializer<T>`
      Parameters:
        `value` - Value to serialize; can not be null.
        `jgen` - Generator used to output resulting Json content
        `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
        `typeSer` - Type serializer to use for including type information
      Throws:
        `IOException`
        `JsonGenerationException`

    - #### serializeContents

          protected abstract void serializeContents(T value,
                               JsonGenerator jgen,
                               SerializerProvider provider)
                                             throws IOException,
                                                    JsonGenerationException

      Throws:
        `IOException`
        `JsonGenerationException`